// This file is part of MinIO DirectPV
// Copyright (c) 2022 MinIO, Inc.
//
// This program is free software: you can redistribute it and/or modify
// it under the terms of the GNU Affero General Public License as published by
// the Free Software Foundation, either version 3 of the License, or
// (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU Affero General Public License for more details.
//
// You should have received a copy of the GNU Affero General Public License
// along with this program.  If not, see <http://www.gnu.org/licenses/>.

// Code generated by client-gen. DO NOT EDIT.

package fake

import (
	"context"

	v1beta1 "github.com/minio/directpv/pkg/apis/directpv.min.io/v1beta1"
	v1 "k8s.io/apimachinery/pkg/apis/meta/v1"
	labels "k8s.io/apimachinery/pkg/labels"
	types "k8s.io/apimachinery/pkg/types"
	watch "k8s.io/apimachinery/pkg/watch"
	testing "k8s.io/client-go/testing"
)

// FakeDirectPVDrives implements DirectPVDriveInterface
type FakeDirectPVDrives struct {
	Fake *FakeDirectpvV1beta1
}

var directpvdrivesResource = v1beta1.SchemeGroupVersion.WithResource("directpvdrives")

var directpvdrivesKind = v1beta1.SchemeGroupVersion.WithKind("DirectPVDrive")

// Get takes name of the directPVDrive, and returns the corresponding directPVDrive object, and an error if there is any.
func (c *FakeDirectPVDrives) Get(ctx context.Context, name string, options v1.GetOptions) (result *v1beta1.DirectPVDrive, err error) {
	obj, err := c.Fake.
		Invokes(testing.NewRootGetAction(directpvdrivesResource, name), &v1beta1.DirectPVDrive{})
	if obj == nil {
		return nil, err
	}
	return obj.(*v1beta1.DirectPVDrive), err
}

// List takes label and field selectors, and returns the list of DirectPVDrives that match those selectors.
func (c *FakeDirectPVDrives) List(ctx context.Context, opts v1.ListOptions) (result *v1beta1.DirectPVDriveList, err error) {
	obj, err := c.Fake.
		Invokes(testing.NewRootListAction(directpvdrivesResource, directpvdrivesKind, opts), &v1beta1.DirectPVDriveList{})
	if obj == nil {
		return nil, err
	}

	label, _, _ := testing.ExtractFromListOptions(opts)
	if label == nil {
		label = labels.Everything()
	}
	list := &v1beta1.DirectPVDriveList{ListMeta: obj.(*v1beta1.DirectPVDriveList).ListMeta}
	for _, item := range obj.(*v1beta1.DirectPVDriveList).Items {
		if label.Matches(labels.Set(item.Labels)) {
			list.Items = append(list.Items, item)
		}
	}
	return list, err
}

// Watch returns a watch.Interface that watches the requested directPVDrives.
func (c *FakeDirectPVDrives) Watch(ctx context.Context, opts v1.ListOptions) (watch.Interface, error) {
	return c.Fake.
		InvokesWatch(testing.NewRootWatchAction(directpvdrivesResource, opts))
}

// Create takes the representation of a directPVDrive and creates it.  Returns the server's representation of the directPVDrive, and an error, if there is any.
func (c *FakeDirectPVDrives) Create(ctx context.Context, directPVDrive *v1beta1.DirectPVDrive, opts v1.CreateOptions) (result *v1beta1.DirectPVDrive, err error) {
	obj, err := c.Fake.
		Invokes(testing.NewRootCreateAction(directpvdrivesResource, directPVDrive), &v1beta1.DirectPVDrive{})
	if obj == nil {
		return nil, err
	}
	return obj.(*v1beta1.DirectPVDrive), err
}

// Update takes the representation of a directPVDrive and updates it. Returns the server's representation of the directPVDrive, and an error, if there is any.
func (c *FakeDirectPVDrives) Update(ctx context.Context, directPVDrive *v1beta1.DirectPVDrive, opts v1.UpdateOptions) (result *v1beta1.DirectPVDrive, err error) {
	obj, err := c.Fake.
		Invokes(testing.NewRootUpdateAction(directpvdrivesResource, directPVDrive), &v1beta1.DirectPVDrive{})
	if obj == nil {
		return nil, err
	}
	return obj.(*v1beta1.DirectPVDrive), err
}

// UpdateStatus was generated because the type contains a Status member.
// Add a +genclient:noStatus comment above the type to avoid generating UpdateStatus().
func (c *FakeDirectPVDrives) UpdateStatus(ctx context.Context, directPVDrive *v1beta1.DirectPVDrive, opts v1.UpdateOptions) (*v1beta1.DirectPVDrive, error) {
	obj, err := c.Fake.
		Invokes(testing.NewRootUpdateSubresourceAction(directpvdrivesResource, "status", directPVDrive), &v1beta1.DirectPVDrive{})
	if obj == nil {
		return nil, err
	}
	return obj.(*v1beta1.DirectPVDrive), err
}

// Delete takes name of the directPVDrive and deletes it. Returns an error if one occurs.
func (c *FakeDirectPVDrives) Delete(ctx context.Context, name string, opts v1.DeleteOptions) error {
	_, err := c.Fake.
		Invokes(testing.NewRootDeleteActionWithOptions(directpvdrivesResource, name, opts), &v1beta1.DirectPVDrive{})
	return err
}

// DeleteCollection deletes a collection of objects.
func (c *FakeDirectPVDrives) DeleteCollection(ctx context.Context, opts v1.DeleteOptions, listOpts v1.ListOptions) error {
	action := testing.NewRootDeleteCollectionAction(directpvdrivesResource, listOpts)

	_, err := c.Fake.Invokes(action, &v1beta1.DirectPVDriveList{})
	return err
}

// Patch applies the patch and returns the patched directPVDrive.
func (c *FakeDirectPVDrives) Patch(ctx context.Context, name string, pt types.PatchType, data []byte, opts v1.PatchOptions, subresources ...string) (result *v1beta1.DirectPVDrive, err error) {
	obj, err := c.Fake.
		Invokes(testing.NewRootPatchSubresourceAction(directpvdrivesResource, name, pt, data, subresources...), &v1beta1.DirectPVDrive{})
	if obj == nil {
		return nil, err
	}
	return obj.(*v1beta1.DirectPVDrive), err
}
