// This file is part of MinIO DirectPV
// Copyright (c) 2022 MinIO, Inc.
//
// This program is free software: you can redistribute it and/or modify
// it under the terms of the GNU Affero General Public License as published by
// the Free Software Foundation, either version 3 of the License, or
// (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU Affero General Public License for more details.
//
// You should have received a copy of the GNU Affero General Public License
// along with this program.  If not, see <http://www.gnu.org/licenses/>.

// Code generated by client-gen. DO NOT EDIT.

package fake

import (
	"context"

	v1beta1 "github.com/minio/directpv/pkg/apis/directpv.min.io/v1beta1"
	v1 "k8s.io/apimachinery/pkg/apis/meta/v1"
	labels "k8s.io/apimachinery/pkg/labels"
	types "k8s.io/apimachinery/pkg/types"
	watch "k8s.io/apimachinery/pkg/watch"
	testing "k8s.io/client-go/testing"
)

// FakeDirectPVNodes implements DirectPVNodeInterface
type FakeDirectPVNodes struct {
	Fake *FakeDirectpvV1beta1
}

var directpvnodesResource = v1beta1.SchemeGroupVersion.WithResource("directpvnodes")

var directpvnodesKind = v1beta1.SchemeGroupVersion.WithKind("DirectPVNode")

// Get takes name of the directPVNode, and returns the corresponding directPVNode object, and an error if there is any.
func (c *FakeDirectPVNodes) Get(ctx context.Context, name string, options v1.GetOptions) (result *v1beta1.DirectPVNode, err error) {
	obj, err := c.Fake.
		Invokes(testing.NewRootGetAction(directpvnodesResource, name), &v1beta1.DirectPVNode{})
	if obj == nil {
		return nil, err
	}
	return obj.(*v1beta1.DirectPVNode), err
}

// List takes label and field selectors, and returns the list of DirectPVNodes that match those selectors.
func (c *FakeDirectPVNodes) List(ctx context.Context, opts v1.ListOptions) (result *v1beta1.DirectPVNodeList, err error) {
	obj, err := c.Fake.
		Invokes(testing.NewRootListAction(directpvnodesResource, directpvnodesKind, opts), &v1beta1.DirectPVNodeList{})
	if obj == nil {
		return nil, err
	}

	label, _, _ := testing.ExtractFromListOptions(opts)
	if label == nil {
		label = labels.Everything()
	}
	list := &v1beta1.DirectPVNodeList{ListMeta: obj.(*v1beta1.DirectPVNodeList).ListMeta}
	for _, item := range obj.(*v1beta1.DirectPVNodeList).Items {
		if label.Matches(labels.Set(item.Labels)) {
			list.Items = append(list.Items, item)
		}
	}
	return list, err
}

// Watch returns a watch.Interface that watches the requested directPVNodes.
func (c *FakeDirectPVNodes) Watch(ctx context.Context, opts v1.ListOptions) (watch.Interface, error) {
	return c.Fake.
		InvokesWatch(testing.NewRootWatchAction(directpvnodesResource, opts))
}

// Create takes the representation of a directPVNode and creates it.  Returns the server's representation of the directPVNode, and an error, if there is any.
func (c *FakeDirectPVNodes) Create(ctx context.Context, directPVNode *v1beta1.DirectPVNode, opts v1.CreateOptions) (result *v1beta1.DirectPVNode, err error) {
	obj, err := c.Fake.
		Invokes(testing.NewRootCreateAction(directpvnodesResource, directPVNode), &v1beta1.DirectPVNode{})
	if obj == nil {
		return nil, err
	}
	return obj.(*v1beta1.DirectPVNode), err
}

// Update takes the representation of a directPVNode and updates it. Returns the server's representation of the directPVNode, and an error, if there is any.
func (c *FakeDirectPVNodes) Update(ctx context.Context, directPVNode *v1beta1.DirectPVNode, opts v1.UpdateOptions) (result *v1beta1.DirectPVNode, err error) {
	obj, err := c.Fake.
		Invokes(testing.NewRootUpdateAction(directpvnodesResource, directPVNode), &v1beta1.DirectPVNode{})
	if obj == nil {
		return nil, err
	}
	return obj.(*v1beta1.DirectPVNode), err
}

// UpdateStatus was generated because the type contains a Status member.
// Add a +genclient:noStatus comment above the type to avoid generating UpdateStatus().
func (c *FakeDirectPVNodes) UpdateStatus(ctx context.Context, directPVNode *v1beta1.DirectPVNode, opts v1.UpdateOptions) (*v1beta1.DirectPVNode, error) {
	obj, err := c.Fake.
		Invokes(testing.NewRootUpdateSubresourceAction(directpvnodesResource, "status", directPVNode), &v1beta1.DirectPVNode{})
	if obj == nil {
		return nil, err
	}
	return obj.(*v1beta1.DirectPVNode), err
}

// Delete takes name of the directPVNode and deletes it. Returns an error if one occurs.
func (c *FakeDirectPVNodes) Delete(ctx context.Context, name string, opts v1.DeleteOptions) error {
	_, err := c.Fake.
		Invokes(testing.NewRootDeleteActionWithOptions(directpvnodesResource, name, opts), &v1beta1.DirectPVNode{})
	return err
}

// DeleteCollection deletes a collection of objects.
func (c *FakeDirectPVNodes) DeleteCollection(ctx context.Context, opts v1.DeleteOptions, listOpts v1.ListOptions) error {
	action := testing.NewRootDeleteCollectionAction(directpvnodesResource, listOpts)

	_, err := c.Fake.Invokes(action, &v1beta1.DirectPVNodeList{})
	return err
}

// Patch applies the patch and returns the patched directPVNode.
func (c *FakeDirectPVNodes) Patch(ctx context.Context, name string, pt types.PatchType, data []byte, opts v1.PatchOptions, subresources ...string) (result *v1beta1.DirectPVNode, err error) {
	obj, err := c.Fake.
		Invokes(testing.NewRootPatchSubresourceAction(directpvnodesResource, name, pt, data, subresources...), &v1beta1.DirectPVNode{})
	if obj == nil {
		return nil, err
	}
	return obj.(*v1beta1.DirectPVNode), err
}
