// This file is part of MinIO DirectPV
// Copyright (c) 2022 MinIO, Inc.
//
// This program is free software: you can redistribute it and/or modify
// it under the terms of the GNU Affero General Public License as published by
// the Free Software Foundation, either version 3 of the License, or
// (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU Affero General Public License for more details.
//
// You should have received a copy of the GNU Affero General Public License
// along with this program.  If not, see <http://www.gnu.org/licenses/>.

// Code generated by client-gen. DO NOT EDIT.

package fake

import (
	"context"

	v1beta1 "github.com/minio/directpv/pkg/apis/directpv.min.io/v1beta1"
	v1 "k8s.io/apimachinery/pkg/apis/meta/v1"
	labels "k8s.io/apimachinery/pkg/labels"
	types "k8s.io/apimachinery/pkg/types"
	watch "k8s.io/apimachinery/pkg/watch"
	testing "k8s.io/client-go/testing"
)

// FakeDirectPVVolumes implements DirectPVVolumeInterface
type FakeDirectPVVolumes struct {
	Fake *FakeDirectpvV1beta1
}

var directpvvolumesResource = v1beta1.SchemeGroupVersion.WithResource("directpvvolumes")

var directpvvolumesKind = v1beta1.SchemeGroupVersion.WithKind("DirectPVVolume")

// Get takes name of the directPVVolume, and returns the corresponding directPVVolume object, and an error if there is any.
func (c *FakeDirectPVVolumes) Get(ctx context.Context, name string, options v1.GetOptions) (result *v1beta1.DirectPVVolume, err error) {
	obj, err := c.Fake.
		Invokes(testing.NewRootGetAction(directpvvolumesResource, name), &v1beta1.DirectPVVolume{})
	if obj == nil {
		return nil, err
	}
	return obj.(*v1beta1.DirectPVVolume), err
}

// List takes label and field selectors, and returns the list of DirectPVVolumes that match those selectors.
func (c *FakeDirectPVVolumes) List(ctx context.Context, opts v1.ListOptions) (result *v1beta1.DirectPVVolumeList, err error) {
	obj, err := c.Fake.
		Invokes(testing.NewRootListAction(directpvvolumesResource, directpvvolumesKind, opts), &v1beta1.DirectPVVolumeList{})
	if obj == nil {
		return nil, err
	}

	label, _, _ := testing.ExtractFromListOptions(opts)
	if label == nil {
		label = labels.Everything()
	}
	list := &v1beta1.DirectPVVolumeList{ListMeta: obj.(*v1beta1.DirectPVVolumeList).ListMeta}
	for _, item := range obj.(*v1beta1.DirectPVVolumeList).Items {
		if label.Matches(labels.Set(item.Labels)) {
			list.Items = append(list.Items, item)
		}
	}
	return list, err
}

// Watch returns a watch.Interface that watches the requested directPVVolumes.
func (c *FakeDirectPVVolumes) Watch(ctx context.Context, opts v1.ListOptions) (watch.Interface, error) {
	return c.Fake.
		InvokesWatch(testing.NewRootWatchAction(directpvvolumesResource, opts))
}

// Create takes the representation of a directPVVolume and creates it.  Returns the server's representation of the directPVVolume, and an error, if there is any.
func (c *FakeDirectPVVolumes) Create(ctx context.Context, directPVVolume *v1beta1.DirectPVVolume, opts v1.CreateOptions) (result *v1beta1.DirectPVVolume, err error) {
	obj, err := c.Fake.
		Invokes(testing.NewRootCreateAction(directpvvolumesResource, directPVVolume), &v1beta1.DirectPVVolume{})
	if obj == nil {
		return nil, err
	}
	return obj.(*v1beta1.DirectPVVolume), err
}

// Update takes the representation of a directPVVolume and updates it. Returns the server's representation of the directPVVolume, and an error, if there is any.
func (c *FakeDirectPVVolumes) Update(ctx context.Context, directPVVolume *v1beta1.DirectPVVolume, opts v1.UpdateOptions) (result *v1beta1.DirectPVVolume, err error) {
	obj, err := c.Fake.
		Invokes(testing.NewRootUpdateAction(directpvvolumesResource, directPVVolume), &v1beta1.DirectPVVolume{})
	if obj == nil {
		return nil, err
	}
	return obj.(*v1beta1.DirectPVVolume), err
}

// UpdateStatus was generated because the type contains a Status member.
// Add a +genclient:noStatus comment above the type to avoid generating UpdateStatus().
func (c *FakeDirectPVVolumes) UpdateStatus(ctx context.Context, directPVVolume *v1beta1.DirectPVVolume, opts v1.UpdateOptions) (*v1beta1.DirectPVVolume, error) {
	obj, err := c.Fake.
		Invokes(testing.NewRootUpdateSubresourceAction(directpvvolumesResource, "status", directPVVolume), &v1beta1.DirectPVVolume{})
	if obj == nil {
		return nil, err
	}
	return obj.(*v1beta1.DirectPVVolume), err
}

// Delete takes name of the directPVVolume and deletes it. Returns an error if one occurs.
func (c *FakeDirectPVVolumes) Delete(ctx context.Context, name string, opts v1.DeleteOptions) error {
	_, err := c.Fake.
		Invokes(testing.NewRootDeleteActionWithOptions(directpvvolumesResource, name, opts), &v1beta1.DirectPVVolume{})
	return err
}

// DeleteCollection deletes a collection of objects.
func (c *FakeDirectPVVolumes) DeleteCollection(ctx context.Context, opts v1.DeleteOptions, listOpts v1.ListOptions) error {
	action := testing.NewRootDeleteCollectionAction(directpvvolumesResource, listOpts)

	_, err := c.Fake.Invokes(action, &v1beta1.DirectPVVolumeList{})
	return err
}

// Patch applies the patch and returns the patched directPVVolume.
func (c *FakeDirectPVVolumes) Patch(ctx context.Context, name string, pt types.PatchType, data []byte, opts v1.PatchOptions, subresources ...string) (result *v1beta1.DirectPVVolume, err error) {
	obj, err := c.Fake.
		Invokes(testing.NewRootPatchSubresourceAction(directpvvolumesResource, name, pt, data, subresources...), &v1beta1.DirectPVVolume{})
	if obj == nil {
		return nil, err
	}
	return obj.(*v1beta1.DirectPVVolume), err
}
